import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { HjmExamLog, HjmExamLogParam } from './model';

/**
 * 分页查询黄家明_学习记录
 */
export async function pageHjmExamLog(params: HjmExamLogParam) {
  const res = await request.get<ApiResult<PageResult<HjmExamLog>>>(
    '/hjm/hjm-exam-log/page',
    params
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询黄家明_学习记录列表
 */
export async function listHjmExamLog(params?: HjmExamLogParam) {
  const res = await request.get<ApiResult<HjmExamLog[]>>(
    '/hjm/hjm-exam-log',
    params
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加黄家明_学习记录
 */
export async function addHjmExamLog(data: HjmExamLog) {
  const res = await request.post<ApiResult<unknown>>(
    '/hjm/hjm-exam-log',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改黄家明_学习记录
 */
export async function updateHjmExamLog(data: HjmExamLog) {
  const res = await request.put<ApiResult<unknown>>(
    '/hjm/hjm-exam-log',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除黄家明_学习记录
 */
export async function removeHjmExamLog(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/hjm/hjm-exam-log/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除黄家明_学习记录
 */
export async function removeBatchHjmExamLog(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/hjm/hjm-exam-log/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询黄家明_学习记录
 */
export async function getHjmExamLog(id: number) {
  const res = await request.get<ApiResult<HjmExamLog>>(
    '/hjm/hjm-exam-log/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}


export async function checkMonthTaskCompleted() {
  const res = await request.get<ApiResult<HjmExamLog>>(
    '/hjm/hjm-exam-log/checkMonthTaskCompleted'
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}


